# Autogenerated wrapper script for libpolymake_julia_jll for x86_64-apple-darwin14-cxx11
export libpolymake_julia, polymake_run_script, type_translator

using CompilerSupportLibraries_jll
using libcxxwrap_julia_jll
using polymake_jll
## Global variables
PATH = ""
LIBPATH = ""
LIBPATH_env = "DYLD_FALLBACK_LIBRARY_PATH"
LIBPATH_default = "~/lib:/usr/local/lib:/lib:/usr/lib"

# Relative path to `libpolymake_julia`
const libpolymake_julia_splitpath = ["lib", "libpolymake_julia.dylib"]

# This will be filled out by __init__() for all products, as it must be done at runtime
libpolymake_julia_path = ""

# libpolymake_julia-specific global declaration
# This will be filled out by __init__()
libpolymake_julia_handle = C_NULL

# This must be `const` so that we can use it with `ccall()`
const libpolymake_julia = "@rpath/libpolymake_julia.dylib"


# Relative path to `polymake_run_script`
const polymake_run_script_splitpath = ["bin", "polymake_run_script"]

# This will be filled out by __init__() for all products, as it must be done at runtime
polymake_run_script_path = ""

# polymake_run_script-specific global declaration
function polymake_run_script(f::Function; adjust_PATH::Bool = true, adjust_LIBPATH::Bool = true)
    global PATH, LIBPATH
    env_mapping = Dict{String,String}()
    if adjust_PATH
        if !isempty(get(ENV, "PATH", ""))
            env_mapping["PATH"] = string(PATH, ':', ENV["PATH"])
        else
            env_mapping["PATH"] = PATH
        end
    end
    if adjust_LIBPATH
        LIBPATH_base = get(ENV, LIBPATH_env, expanduser(LIBPATH_default))
        if !isempty(LIBPATH_base)
            env_mapping[LIBPATH_env] = string(LIBPATH, ':', LIBPATH_base)
        else
            env_mapping[LIBPATH_env] = LIBPATH
        end
    end
    withenv(env_mapping...) do
        f(polymake_run_script_path)
    end
end


# Relative path to `type_translator`
const type_translator_splitpath = ["share", "libpolymake_julia", "type_translator.jl"]

# This will be filled out by __init__() for all products, as it must be done at runtime
type_translator_path = ""

# type_translator-specific global declaration
# This will be filled out by __init__()
type_translator = ""


# Inform that the wrapper is available for this platform
wrapper_available = true

"""
Open all libraries
"""
function __init__()
    # This either calls `@artifact_str()`, or returns a constant string if we're overridden.
    global artifact_dir = find_artifact_dir()

    global PATH_list, LIBPATH_list
    # Initialize PATH and LIBPATH environment variable listings
    # From the list of our dependencies, generate a tuple of all the PATH and LIBPATH lists,
    # then append them to our own.
    foreach(p -> append!(PATH_list, p), (CompilerSupportLibraries_jll.PATH_list, libcxxwrap_julia_jll.PATH_list, polymake_jll.PATH_list,))
    foreach(p -> append!(LIBPATH_list, p), (CompilerSupportLibraries_jll.LIBPATH_list, libcxxwrap_julia_jll.LIBPATH_list, polymake_jll.LIBPATH_list,))

    global libpolymake_julia_path = normpath(joinpath(artifact_dir, libpolymake_julia_splitpath...))

    # Manually `dlopen()` this right now so that future invocations
    # of `ccall` with its `SONAME` will find this path immediately.
    global libpolymake_julia_handle = dlopen(libpolymake_julia_path, RTLD_LAZY | RTLD_DEEPBIND)
    push!(LIBPATH_list, dirname(libpolymake_julia_path))

    global polymake_run_script_path = normpath(joinpath(artifact_dir, polymake_run_script_splitpath...))

    push!(PATH_list, dirname(polymake_run_script_path))
    global type_translator_path = normpath(joinpath(artifact_dir, type_translator_splitpath...))

    global type_translator = type_translator_path
    # Filter out duplicate and empty entries in our PATH and LIBPATH entries
    filter!(!isempty, unique!(PATH_list))
    filter!(!isempty, unique!(LIBPATH_list))
    global PATH = join(PATH_list, ':')
    global LIBPATH = join(vcat(LIBPATH_list, [joinpath(Sys.BINDIR, Base.LIBDIR, "julia"), joinpath(Sys.BINDIR, Base.LIBDIR)]), ':')

    
end  # __init__()
